//
// (c)Copyright Spacesoft corp., 2006 All rights reserved.
//                                    Kitayama, Hiroyuki
//
#include <stdio.h>
#include <stdlib.h>

int main( int argc, char *argv[] )
{
    __declspec(align(16)) float src[2];
    __declspec(align(16)) float tmp[4];
    __declspec(align(16)) float dst[4];

    if( argc != 5 )
    {
        fprintf(stderr, "usage: pgm [arg1] [arg2]\n");
        return -1;
    }

    src[3] = (float)atof(argv[1]);
    src[2] = (float)atof(argv[2]);
    src[1] = (float)atof(argv[3]);
    src[0] = (float)atof(argv[4]);

    __asm
    {
		xorps		xmm1,  xmm1
        movaps      xmm0,  src       // 
        movhlps     xmm1,  xmm0
        movaps      tmp,   xmm0
        movaps      dst,   xmm1
    }

    printf("     source   : %12.4f, %12.4f, %12.4f, %12.4f\n",
                                src[3], src[2], src[1], src[0]);
    printf("     temporal : %12.4f, %12.4f, %12.4f, %12.4f\n",
                                tmp[3], tmp[2], tmp[1], tmp[0]);
    printf("     result   : %12.4f, %12.4f, %12.4f, %12.4f\n",
                                dst[3], dst[2], dst[1], dst[0]);

    return 0;
}